import { __awaiter, __generator } from "tslib";
import { getConfig } from './helper';
import { Router } from './router';
import { LoginMethodType } from './types';
import { providerLogin } from './index';
export function tryWecomLogin(location, fallback) {
    return __awaiter(this, void 0, void 0, function () {
        var router, config, loginMethods, loginTypes_1, authList_1, wecomConfig_1, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 5, , 6]);
                    router = new Router(document.createElement('div'), location);
                    return [4 /*yield*/, getConfig(router)];
                case 1:
                    config = _a.sent();
                    loginMethods = (config === null || config === void 0 ? void 0 : config.web) || [];
                    loginTypes_1 = [];
                    authList_1 = [];
                    wecomConfig_1 = undefined;
                    loginMethods.forEach(function (item) {
                        if (!loginTypes_1.includes(item.type)) {
                            loginTypes_1.push(item.type);
                        }
                        if (item.type === LoginMethodType.AUTH) {
                            authList_1.push(item);
                        }
                        if (item.id === 'wecom') {
                            wecomConfig_1 = item;
                        }
                    });
                    if (!wecomConfig_1) return [3 /*break*/, 3];
                    return [4 /*yield*/, providerLogin(router, wecomConfig_1.id)];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
                case 3:
                    fallback();
                    _a.label = 4;
                case 4: return [3 /*break*/, 6];
                case 5:
                    e_1 = _a.sent();
                    console.error('企微原地登录失败，fallback to sso登录', e_1);
                    fallback();
                    return [3 /*break*/, 6];
                case 6: return [2 /*return*/];
            }
        });
    });
}
