"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.tryWecomLogin = void 0;
var tslib_1 = require("tslib");
var helper_1 = require("./helper");
var router_1 = require("./router");
var types_1 = require("./types");
var index_1 = require("./index");
function tryWecomLogin(location, fallback) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var router, config, loginMethods, loginTypes_1, authList_1, wecomConfig_1, e_1;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 5, , 6]);
                    router = new router_1.Router(document.createElement('div'), location);
                    return [4 /*yield*/, (0, helper_1.getConfig)(router)];
                case 1:
                    config = _a.sent();
                    loginMethods = (config === null || config === void 0 ? void 0 : config.web) || [];
                    loginTypes_1 = [];
                    authList_1 = [];
                    wecomConfig_1 = undefined;
                    loginMethods.forEach(function (item) {
                        if (!loginTypes_1.includes(item.type)) {
                            loginTypes_1.push(item.type);
                        }
                        if (item.type === types_1.LoginMethodType.AUTH) {
                            authList_1.push(item);
                        }
                        if (item.id === 'wecom') {
                            wecomConfig_1 = item;
                        }
                    });
                    if (!wecomConfig_1) return [3 /*break*/, 3];
                    return [4 /*yield*/, (0, index_1.providerLogin)(router, wecomConfig_1.id)];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
                case 3:
                    fallback();
                    _a.label = 4;
                case 4: return [3 /*break*/, 6];
                case 5:
                    e_1 = _a.sent();
                    console.error('企微原地登录失败，fallback to sso登录', e_1);
                    fallback();
                    return [3 /*break*/, 6];
                case 6: return [2 /*return*/];
            }
        });
    });
}
exports.tryWecomLogin = tryWecomLogin;
//# sourceMappingURL=init.js.map